//  name	- Fl_Dir.C
//  programmer	- C Edwards
//  Incept	- 5/98
//  Description	- subclass of Fl_Button that draws pixmaps with lables
//                each pixmap will draw UP/DOWN/HILIGHT 
//  
//  Usage	-
//  Changes	- Ver.1
#include <FL/fl_draw.H>
#include "Fl_Frametab.H"

////constructor
Fl_Frametab::Fl_Frametab(int x,int y,int w, int h, char *fname)
: Fl_Group(x, y, w, h<MINFRAMEHEIGHT ? MINFRAMEHEIGHT : h,"")
{
  box(FL_ENGRAVED_BOX);
  align(20);
  resizable(NULL);
  title   = fname;
  Hsize   =  h<MINFRAMEHEIGHT ? MINFRAMEHEIGHT : h;
  isopen  = 1;            //TRUE/FALSE
}

////draw the button
void Fl_Frametab::draw()
{
 if(!isopen) fl_draw_box(FL_FLAT_BOX,x(), y(), w(), Hsize, parent()->color());
 Fl_Group::draw();
 int midX=16+x(), midY=y()+(MINFRAMEHEIGHT/2);
 if(isopen) 
 {
   fl_color(FL_WHITE);
   fl_polygon(midX+5, midY-2, midX, midY+3, midX-5, midY-2); 
   fl_color(FL_BLACK);
   fl_loop(midX+5, midY-2, midX, midY+3, midX-5, midY-2); 
 }
 else
 {
   fl_color(FL_WHITE);
   fl_polygon(midX-2, midY-5, midX+3, midY, midX-2, midY+5); 
   fl_color(FL_BLACK);
   fl_loop(midX-2, midY-5, midX+3, midY, midX-2, midY+5); 
 }
 fl_draw(title, midX+12, y(), w(), MINFRAMEHEIGHT, FL_ALIGN_LEFT);
}

////handel the events
int Fl_Frametab::handle(int event)
{
   switch (event) 
  {
     case FL_PUSH:
                     if (Fl::event_inside(x(), y(), w(), MINFRAMEHEIGHT-2))
		     {
                        if(isopen) close();
                        else open();
                        return 0;
		     }
     default:
                     return Fl_Group::handle(event);

   }
}
//// close the frame 
void Fl_Frametab::close()
{
   int nchild = children();
   Fl_Widget*const* a = array();
   Fl_Widget* o;
   isopen=0;
   for (int i=0; i < nchild; i++) 
   {   o = *a++;
       o->hide();
   }
   h(MINFRAMEHEIGHT);
   redraw();
}

//// close the frame 
void Fl_Frametab::open()
{
   int nchild = children();
   Fl_Widget*const* a = array();
   Fl_Widget* o;
   isopen=1;
   for (int i=0; i < nchild; i++) 
   {   o = *a++;
       o->show();
       o->damage(~1);
   }
   h(Hsize);
   redraw();
}
